/*
	SNES region patcher test application
	Mic, 2010
*/

#include "SnesRegionPatcher.h"


void show_help()
{
	printf("Usage: snespatcher [options] <input> [output]\n");
	printf("\nOptions:\n");
	printf("\t-pal\tApply PAL fix\n");
	printf("\t-ntsc\tApply NTSC fix\n");
}


int main(int argc, char **argv)
{
	SnesRegionPatcher patcher;
	int region = -1;
	int i;
	int numPatches;

	if (argc < 3)
	{
		show_help();
        return 0;
    }
    
    for (i=1; i<argc; i++)
    {
        if (argv[i][0] == '-')
        {
			if ((strcmp(argv[i], "-h")==0) ||
				(strcmp(argv[i], "-help")==0) ||
				(strcmp(argv[i], "-?")==0))
			{
				show_help();
				return 0;
			}
			if (strcmp(argv[i], "-pal")==0)
			{
				region = SnesRegionPatcher::REGION_PAL;
			}
			if (strcmp(argv[i], "-ntsc")==0)
			{
				region = SnesRegionPatcher::REGION_NTSC;
			}
		}
		else
		{
			break;
		}
	}

	if ((i >= argc) || (region == -1))
	{
		show_help();
		return 0;
	}

	if (argc > i + 1)
	{
		numPatches = patcher.Patch(region, argv[i], argv[i + 1]);
	}
	else
	{
		numPatches = patcher.Patch(region, argv[i]);
	}

	printf("\nDone!\nThe file was patched %d time(s).\n", numPatches);

	return 0;
}
